//******************************************************************************
// FILE..........: 2_second_example.cpp
// DESCRIPTION...: the simplest example using of FastCpp::BTreeArray
// AUTHOR........: Dmitry Vinogradov
// COPYRIGHT.....: Copyright(c) FastCpp 2014, Dmitry Vinogradov
// LICENSE.......: "2 EUR" or "advertising note at the about box"
//                 See http://www.FastCpp.com/license.html
//
// HISTORY.......: DATE       COMMENT
//                 ---------- -------------------------------------------------
//                     y  m  d
//                 2014-09-30 Created by Dmitry Vinogradov
//******************************************************************************

#include <iostream>

//-------------------------------------------------------------------------------------------------------------
// if in Visual Studio you have the error:
// fatal error C1083: Cannot open include file: 'FastCpp/BTreeArray/BTreeArray.hpp': No such file or directory
// in the following line:
#include <FastCpp/BTreeArray/BTreeArray.hpp>
// then the FastCpp enviroment variable does not have correct path.
// See FastCpp\SetEnvFastCpp.bat file.
//-------------------------------------------------------------------------------------------------------------


int main(int argc, char* argv[])
{
  namespace F = FastCpp;

  F::BTreeArray<int> vec;

  vec.push_back(100);
  vec.insert(vec.begin(), 200);

  int arr[10] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
  vec.insert(vec.begin() + 1, arr, arr + 10);
  vec[0] = 1000;

  // new possibilities:
  //
  // insert at the beginning
  vec.begin().Insert(-3).Insert(-2).Insert(-1);  
  vec.push_front(42);

  // pop_front
  vec.pop_front();

  // insert in the middle:
  size_t nPosition = vec.size() / 2;
  vec.Insert(nPosition, 1234);

  // remove 
  vec.RemoveRange(10, 14);

  // result
  for(
      F::BTreeArray<int>::const_iterator it    = vec.cbegin(),
                                         itEnd = vec.cend();
      itEnd != it;
      ++it
     )
  {
    std::cout << *it << ' ';
  }
  std::cout << std::endl;
  // output: -1 -2 -3 1000 0 1 2 1234 3 4 100

  return 0;
}


//** (END OF FILE  : 2_second_example.cpp) *************************************
