//*****************************************************************************
// FILE..........: BTreeArrayInterface.hpp
// AUTHOR........: Dmitry Vinogradov
// COPYRIGHT.....: Copyright(c) FastCpp 2012-2014, Dmitry Vinogradov
// LICENSE.......: "2 EUR" or "advertising note at the about box"
//                 See http://www.FastCpp.com/license.html
//
// HISTORY.......: DATE       COMMENT
//                 ---------- --------------------------------------------------
//                     y  m  d
//                 2013-06-21 Created by Dmitry Vinogradov
//******************************************************************************

//---------------------------------------------------------------- include guard
#ifndef FastCpp_BTREEARRAYINTERFACE_HPP
#define FastCpp_BTREEARRAYINTERFACE_HPP

//--------------------------------------------------------------- import std lib
//------------------------------------------------------------------------------
#ifndef                     FastCpp_BTREEARRAYUPBLOCKINTERFACE_HPP
#include <FastCpp/BTreeArray/detail/BTreeArrayUpBlockInterface.hpp>
#endif//                    FastCpp_BTREEARRAYUPBLOCKINTERFACE_HPP
//------------------------------------------------------------------------------
namespace FastCpp
{
template <class T, class UIndex, class BIndex, BIndex BLOCK_SIZE, class Allocator> class BTreeArrayIterator;

namespace Detail
{
//------------------------------------------------------------------------------
//| |       |                 |                 |                            |


template <class T, class UIndex, class BIndex, BIndex BLOCK_SIZE, class Allocator>
class BTreeArrayInterface : public BTreeArrayUpBlockInterface<T, UIndex, BIndex, BLOCK_SIZE, Allocator>
{
  public:
    virtual                  ~BTreeArrayInterface()
                              {
                              }
    virtual BTreeArrayIterator<T, UIndex, BIndex, BLOCK_SIZE, Allocator>
                              AddBack           (const T& rElemt) = 0;
};


//------------------------------------------------------------------------------
//------------------------------------------------- inline function declarations
//--------------------------------------------------------------- public methods
//------------------------------------------------------------ protected methods
//-------------------------------------------------------------- private methods
//------------------------------------------------------------- inline functions
}// namespace Detail
}// namespace FastCpp
#endif//FastCpp_BTREEARRAYINTERFACE_HPP
//** (END OF FILE  : BTreeArrayInterface.hpp) **********************************
