//*****************************************************************************
// FILE..........: IsInteger.hpp
// DESCRIPTION...: IsInteger metafunction
// AUTHOR........: Dmitry Vinogradov
// COPYRIGHT.....: Copyright(c) FastCpp 2012-2014, Dmitry Vinogradov
// LICENSE.......: "2 EUR" or "advertising note at the about box"
//                 See http://www.FastCpp.com/license.html
//
// HISTORY.......: DATE       COMMENT
//                 ---------- --------------------------------------------------
//                     y  m  d
//                 2013-06-28 Created by Dmitry Vinogradov
//******************************************************************************

//---------------------------------------------------------------- include guard
#ifndef FastCpp_ISINTEGER_HPP
#define FastCpp_ISINTEGER_HPP

//------------------------------------------------------------------------------
#ifndef                 FastCpp_INTEGERTYPE_TAG_HPP
#include <FastCpp/Metafunctions/IntegerType_Tag.hpp>
#endif//                FastCpp_INTEGERTYPE_TAG_HPP
//------------------------------------------------------------------------------
namespace FastCpp
{
//------------------------------------------------------------------------------


template <typename T>
struct IsInteger
{
  enum { is_integer = 0 };
  typedef NotIntegerType_Tag Type;
};


template <>
struct IsInteger<int>
{
  enum { is_integer = 1 };
  typedef IntegerType_Tag Type;
};


//------------------------------------------------------------------------------
}// namespace FastCpp
#endif//FastCpp_ISINTEGER_HPP
//** (END OF FILE  : IsInteger.hpp) ********************************************
